import { __awaiter, __decorate } from "tslib";
import { attr, customElement } from '@genesislcap/web-core';
import { first } from 'rxjs';
import { Fdc3SystemChannelListener, } from './fdc3-system-channel-listener';
/**
 * fdc3-context-listener listen to app channel context
 * @alpha
 */
let Fdc3ContextListener = class Fdc3ContextListener extends Fdc3SystemChannelListener {
    constructor() {
        super(...arguments);
        this.config = [];
    }
    addChannelListeners() {
        this.config.forEach((c) => this.fdc3.addChannelListener(c.channelName, c.channelType, (message) => {
            if (message.type === c.channelType) {
                c.callback(message);
            }
        }));
    }
    addChannelListener() {
        this.fdc3.isReady$.pipe(first()).subscribe(() => __awaiter(this, void 0, void 0, function* () {
            return this.channelSub.add(this.fdc3.currentChannel$.subscribe((channel) => {
                this.fdc3.addChannelListener(this.channelName, this.contextType, (context) => {
                    this.$emit('channel-event', context);
                });
            }));
        }));
    }
};
__decorate([
    attr({ attribute: 'channel-name' })
], Fdc3ContextListener.prototype, "channelName", void 0);
Fdc3ContextListener = __decorate([
    customElement({
        name: 'fdc3-context-listener',
    })
], Fdc3ContextListener);
export { Fdc3ContextListener };
